/*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania C - Trasa
 * Zlozonosc: O(N)
 *
 * Autor programu: Piotr Gawron
 */

#include<stdio.h>
#include<assert.h>
#include<queue>
using namespace std;
struct wlot
{
    int time;
    int skrz, wl;
};
bool operator<(wlot a, wlot b)
{
    return a.time>b.time;
}
priority_queue <wlot> kol;
struct skrzyzowanie
{
    int R[4];
    int G[4];
    int O[4];
    int T[4][4];
    wlot wyloty[4];
    int RD[4];
} sk[10010];
int T[10010][4];
void push(wlot w)
{
    if (T[w.skrz][w.wl]<=w.time&&T[w.skrz][w.wl]>=0)
        return;
    T[w.skrz][w.wl]=w.time;
    kol.push(w);
}
int dj(int p, int wlocik, int k, int t)
{
    int i,j;
    wlot w,w1;
    w.skrz=p;
    while (!kol.empty())
        kol.pop();
    w.wl=wlocik;
    w.time=t;
    push(w);
    while (!kol.empty())
    {
        w=kol.top();
        kol.pop();
        if (w.skrz==k)
            return w.time;
        for (i=0;i<4;i++)
            if (sk[w.skrz].T[w.wl][i]>=0)
            {
                assert(sk[w.skrz].wyloty[i].time>0);
                int RG=sk[w.skrz].R[w.wl]+sk[w.skrz].G[w.wl];
                if ((w.time+200*(RG)-sk[w.skrz].O[w.wl])%(RG)>=sk[w.skrz].R[w.wl])
                {
                    w1=sk[w.skrz].wyloty[i];
                    w1.time+=w.time+sk[w.skrz].T[w.wl][i];
                    push(w1);
                }
                else
                {

                    w1.time= w.time+                                                            //dotychczasowy czas
                             sk[w.skrz].R[w.wl]-((w.time+200*RG-sk[w.skrz].O[w.wl])%(RG))+      //czas oczekiwania na skrz
                             sk[w.skrz].wyloty[i].time+                                         //czas przejazdu przez ulice za skrz
                             sk[w.skrz].T[w.wl][i];                                             //czas przejazdu przez skrzyzowanie

                    w1.skrz=sk[w.skrz].wyloty[i].skrz;
                    w1.wl=sk[w.skrz].wyloty[i].wl;
                    push(w1);
                    if ((w.wl+1)%4==i)          //strzaleczka
                    {
                        w1=sk[w.skrz].wyloty[i];
                        w1.time+=sk[w.skrz].RD[w.wl]+w.time;
                        push(w1);
                    }
                }
            }
    }
    return -1;
    assert(false);
}
int main()
{
    int d,i,j,k,l,m,n;
    int a,b,t;
    char a1[10],b1[10],s[100];
    scanf("%d",&d);
    while (d--)
    {
        scanf("%d%d",&n,&m);
        for (i=1;i<=n;i++)
        {
            for (j=0;j<4;j++)
                scanf("%d",&sk[i].R[j]);
            for (j=0;j<4;j++)
                scanf("%d",&sk[i].G[j]);
            for (j=0;j<4;j++)
                scanf("%d",&sk[i].O[j]);
            for (j=0;j<4;j++)
            {
                scanf("%d",&sk[i].RD[j]);
                sk[i].wyloty[j].time=-1;
                T[i][j]=-1;
            }
            for (j=0;j<4;j++)
                for (k=0;k<4;k++)
                    scanf("%d",&sk[i].T[j][k]);
        }
        for (i=0;i<m;i++)
        {
            scanf("%d%s%d%s%d",&a,&a1,&b,&b1,&t);
            switch (a1[0])
            {
                case('N'):j=0;break;
                case('W'):j=1;break;
                case('S'):j=2;break;
                case('E'):j=3;break;
            }
            switch (b1[0])
            {
                case('N'):k=0;break;
                case('W'):k=1;break;
                case('S'):k=2;break;
                case('E'):k=3;break;
            }
            sk[a].wyloty[j].skrz=b;
            sk[a].wyloty[j].wl=k;
            sk[a].wyloty[j].time=t;
        }
        scanf("%d%s%d%d",&a,&a1,&b,&t);
            switch (a1[0])
            {
                case('N'):j=0;break;
                case('W'):j=1;break;
                case('S'):j=2;break;
                case('E'):j=3;break;
            }
        printf("%d\n",dj(a,j,b,t)-t);
    }
    return 0;
}
