{*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania G - Kryszta
 * Zlozonosc: O(N^3)
 *
 * Autor programu: Wadysaw Bodzek
 *}

const MAX=200;

var
 A: Array[0..MAX,0..MAX] of longint;
 N: Longint;
 D: Longint;
 i, j, k: longint;
 sum, lsum, cnt, x: longint;


begin
  read(D);
  while (D>0) do
  begin
    dec(d);
    read(N);

    for i := 0 to N-1 do
      for j := 0 to N-1 do
        A[i,j] := 0;

    for i := 0 to N-1 do
    begin
      read(cnt);
      for j := 0 to cnt-1 do
      begin
        read(x);
        dec(x);
        A[i,x] := -1;
        A[x,i] := 1;
      end;
    end;

    sum := 0;
    for i := 0 to N-1 do
    begin
      for j := i+1 to N-1 do
      begin
        if (A[i,j]<>0) then continue;

        lsum := 0;
        for k := 0 to N-1 do
        begin
          if ((k = i) or (k = j)) then
            continue;
          if (A[i,k]<>0) and (A[j,k]<>0) then
            inc(lsum);
        end;
        sum := sum + (lsum*(lsum-1) div 2);
      end;
    end;

    writeln(sum);
  end;

end.
