/*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania J - Telefony
 * Zlozonosc: O(M*L+N*2^L)
 *
 * Autor programu: Rafa Witkowski
 */

#include <stdio.h>
#include <string.h>

int d, n, m, l;
char sl[11];
int t[100100][11], kt;
int i,j;
int dlsl, dt, g;
int w;
char test[10];

int odkoduj(char c)
{
  switch (c)
  {
    case 'a' :
    case 'b' :
      return 1;
    case 'c' :
    case 'd' :
      return 2;
    case 'e' :
    case 'f' :
    case 'g' :
      return 3;
    case 'h' :
    case 'i' :
    case 'j' :
      return 4;
    case 'k' :
    case 'l' :
      return 5;
    case 'm' :
    case 'n' :
      return 6;
    case 'o' :
    case 'p' :
      return 7;
    case 'r' :
    case 's' :
      return 8;
    case 't' :
    case 'u' :
      return 9;
    case 'w' :
    case 'y' :
    case 'z' :
      return 0;
    default : printf("Bd w testach!!!");
  }
  return -1;
}

int lic(char c)
{
 return c-48;
}

void pasuj(int co, int poz, int slowo, int wynik)
{
  if (poz==l)
  {
    if (slowo>0) wynik*=t[slowo][10];
    w+=wynik;
  } else
  {
    if (slowo>0)
    {
      if (t[slowo][10]>0)
      {
        wynik*=t[slowo][10];
        t[slowo][10]--;
        pasuj(lic(sl[poz+1]),poz+1,0,wynik);
        t[slowo][10]++;
        wynik/=t[slowo][10];
      }
      if (t[slowo][co]>0)
      {
        pasuj(lic(sl[poz+1]),poz+1,t[slowo][co],wynik);
      }
    } else
    {
      pasuj(lic(sl[poz+1]),poz+1,0,wynik);
      if (t[0][co]>-1) pasuj(lic(sl[poz+1]),poz+1,t[0][co],wynik);
    }
  }
}

int main()
{
  scanf("%d\n",&d);
  while(d--)
  {
    scanf("%d\n",&m);

    kt=0;
    for (i=0; i<11; i++) t[0][i]=-1;
    t[0][10]=0;
    while (m--)
    {
      gets(sl);
      dlsl = strlen(sl);
      if (dlsl>9) continue;
      g=0;
      for (i=0; i<dlsl; i++)
      {
        dt=odkoduj(sl[i]);
        if (t[g][dt]<0)
        {
          kt++;
          t[g][dt]=kt;
          g=kt;
          for (j=0; j<11; j++) t[g][j]=-1;
          t[g][10]=0;
        } else
        {
          g=t[g][dt];
        }
      }
      t[g][10]++;
    }

    scanf("%d %d\n",&n, &l);
    while (n--)
    {
      gets(sl);

      w=0;
      pasuj(lic(sl[1]),1,0,1);
      if (t[0][lic(sl[0])]>-1) pasuj(lic(sl[1]),1,t[0][lic(sl[0])],1);
      printf("%d\n",w);
    }
  }
  return 0;
}
