{*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania J - Telefony
 * Zlozonosc: O(M*L+N*2^L)
 *
 * Autor programu: Rafa Witkowski
 *}

var
  d, n, m, l: longint;
  sl: string;
  t: array[0..100100,0..11] of longint;
  kt: longint;
  i,j : longint;
  dlsl, dt, g: longint;
  w: longint;

function odkoduj(c: char): integer;
begin
  case (c) of
    'a'..'b' : odkoduj := 1;
    'c'..'d' : odkoduj := 2;
    'e'..'g' : odkoduj := 3;
    'h'..'j' : odkoduj := 4;
    'k'..'l' : odkoduj := 5;
    'm'..'n' : odkoduj := 6;
    'o'..'p' : odkoduj := 7;
    'r'..'s' : odkoduj := 8;
    't'..'u' : odkoduj := 9;
    'w'..'z' : odkoduj := 0;
  end;
  odkoduj := -1;
end;

procedure pasuj(co, poz, slowo, wynik: integer);
begin
  if (poz=l) then
  begin
    if (slowo>0) then wynik:=wynik*t[slowo,10];
    w:=w+wynik;
  end else
  begin
    if (slowo>0) then
    begin
      if (t[slowo,10]>0) then
      begin
        wynik:=wynik*t[slowo,10];
        dec(t[slowo,10]);
        pasuj(ord(sl[poz+1]),poz+1,0,wynik);
        inc(t[slowo,10]);
        wynik:=wynik div t[slowo,10];
      end;
      if (t[slowo,co]>0) then
      begin
        pasuj(ord(sl[poz+1]),poz+1,t[slowo,co],wynik);
      end;
    end else
    begin
      pasuj(ord(sl[poz+1]),poz+1,0,wynik);
      if (t[0,co]>-1) then pasuj(ord(sl[poz+1]),poz+1,t[0,co],wynik);
    end;
  end;
end;

begin
  readln(d);
  while(d>0) do
  begin
    dec(d);
    readln(m);

    kt:=0;
    for i:=0 to 10 do t[0,i]:=-1;
    t[0,10]:=0;
    while (m>0) do
    begin
      dec(m);
      readln(sl);
      dlsl := length(sl);
      if (d>9) then continue;
      g:=0;
      for i:=1 to dlsl do
      begin
        dt:=odkoduj(sl[i]);
        if (t[g,dt]<0) then
        begin
          inc(kt);
          t[g,dt]:=kt;
          g:=kt;
          for j:=0 to 10 do t[g,j]:=-1;
          t[g,10]:=0;
        end else
        begin
          g:=t[g,dt];
        end;
      end;
      inc(t[g,10]);
    end;

    readln(n,l);
    while (n>0) do
    begin
      dec(n);
      Readln(sl);

      w:=0;
      pasuj(ord(sl[1]),1,0,1);
      if (t[0,ord(sl[0])]>-1) then pasuj(ord(sl[1]),1,t[0,ord(sl[0])],1);
      Writeln(w);
    end;
  end;
end.
